module.exports = Object.freeze({
  slashSplit(uriString) {
    let string = uriString;
    let returnArray = string.split("/");
    return returnArray;
  },

  getTopLevelDomain(uriString) {
    let index = uriString.lastIndexOf(".");
    let tplDomain = uriString.slice(index)
    return tplDomain;
  },

  containsWWW(uriString) {
    let firstThreeCharacters = uriString.slice(0,3);
    if (firstThreeCharacters == "www")
      return true
    else
      return false
  },

  contains(uriString, target) {
    let indexOfTarget = uriString.lastIndexOf(target);
    if (indexOfTarget != -1)
      return [true, indexOfTarget]
    else
      return false
  },

  returnQueryString(uriString) {
    let queryString = uriString.split("?");
    return queryString[1];
  },

  returnObjectOfQueryParams(uriString) {
    let returnObj = new Object;
    let queryString = uriString.split("?");
    let queryArray = queryString[1].split("&");
    queryArray.forEach((val) => {
      let keyValArray = val.split("=");
      returnObj[keyValArray[0]] = keyValArray[1];
    })
    return returnObj;
  },

  numberOfQueryParams(uriString) {
    let queryString = uriString.split("?");
    let queryArray = queryString[1].split("&");
    return queryArray.length;
  },

  isHTTPS(uriString) {
    let regex = new RegExp("https");
    return regex.test(uriString);
  },

  appendToURL(uriString, key, value) {
    if ( this.contains(uriString, "/?") || this.contains(uriString, "?") ){
      let queryParam = `${key}=${value}`
      return `${uriString}&${queryParam}`
    } else {
      let queryParam = `${key}=${value}`
      if (uriString[uriString.length - 1] == "/")
        return `${uriString}?${queryParam}`
      else
        return `${uriString}/?${queryParam}`
    }
  },

  base64EncodeQueryParamValues(uriString) {
    let returnArray = [];
    let url = uriString.split("?")[0];
    let queryString = uriString.split("?")[1];
    let queryArray = queryString.split("&");
    queryArray.forEach((value) => {
      let keyValArray = value.split("=");
      keyValArray[1] = new Buffer(keyValArray[1]).toString('base64')
      returnArray.push(keyValArray.join("="));
    });
    return `${url}?${returnArray.join("&")}`;
  },

  base64DecodeQueryParamValues(uriString) {
    let url = uriString.split("?")[0];
    let queryString = uriString.split("?")[1];
    let queryArray = queryString.split("&");
    let newQueryArray = queryArray.map((value) => {
      let keyValArray = value.split("=");
      keyValArray[1] = keyValArray[1].toString('utf8');
      return keyValArray.join("=");
    });
    return `${url}?${newQueryArray.join("&")}`;
  },

  convertProtoccol(uriString) {
    let returnUri = "";
    if (uriString.slice(0,5) == "https") {
      returnUri = uriString.replace("https", "http");
    } else {
      uriString.replace("http", "https");
    }
    return returnUri;
  },

});
